      program example
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!     Demonstrates eigensystemn solver
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Parameters
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      implicit none
      integer,parameter           :: r8b= kind(1.D200)
      integer,parameter           :: i4b= kind(2147483647)



      integer(i4b), parameter     :: Nx=8                         ! dimension  of matrix
 
      real(r8b)                   :: Hij(Nx,Nx)                   ! Hamiltonian matrix 
      real(r8b)                   :: d(Nx),e(Nx)                  ! workspace for diagonalization 

      integer(i4b)                :: ix,jx                             ! x index
      integer(i4b)                :: ierr                           ! exit code of tql2  

      external                    :: tred2,tql2
  

! Build matrix !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

     Hij(:,:)=0
     do ix=1,Nx
        Hij(ix,ix)=1.D0
     enddo
     do ix=1,Nx-1
        Hij(ix,ix+1)=-1.D0
        Hij(ix+1,ix)=-1.D0
     enddo
     Hij(1,Nx)=-1.D0
     Hij(Nx,1)=-1.D0

! Diagonalize matrix !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

     call tred2(Nx,Nx,Hij,d,e,Hij)
     call tql2(Nx,Nx,d,e,Hij,ierr) 


     print *,'Eigenvalues' 
     do ix=1,Nx
        write(*,'(I6,1x,F12.6,128(1x,e12.6))') ix,d(ix)
     enddo

     print *,'Eigenvectors' 
     do ix=1,Nx
        write(*,'(I6,128(1x,e12.6))') ix,(Hij(ix,jx),jx=1,Nx)
     enddo


      end  


